function [Ypred, UCL, LCL]=FunctionalGPPredict0(Din1,Din2,Yin,Noin,x,thetaopt,alpha,sigma2,R1,ResR2I,R2I)
%checked#1
%Inputs: [Din1, Din2, Yin, Noin]=same as FunctionalGPFit0, x=input setting at which prediction of functional output at points in M is desired, [thetaopt,alpha,sigma2,R1,ResR2I,R2I]=the outputs of FunctionalGPFit0.
%Outputs: Ypred=vector of point predictions, UCL=vector of upper prediction/credible interval limits (0.99 quantile), LCL=vector of lower prediction/credible interval limits (0.01 quantile)

global D1 D2 Y n No n1 n2 d1 d2

No=Noin;
D1=Din1;
D2=Din2;
Y=Yin;
[n1, d1]=size(D1);
[n2, d2]=size(D2);
n=n1*n2;

m=size(x,1);
R3=zeros(n2,m);
for i=1:n2
    for j=1:m
        R3(i,j)=CompCorr(D2(i,:),x(j,:),thetaopt((d1+1):end));
    end
end
Ypred=alpha+ResR2I*R3;
Ypred=Ypred(:);

PosVar=zeros(n1,m);
for j=1:m  
    PosVar(:,j)=sigma2*diag(R1)*(1-(R3(:,j)')*R2I*(R3(:,j)));
end

RMSE=sqrt(max(reshape(PosVar,m*n1,1),0));
LCL=Ypred-norminv(0.99)*RMSE;
UCL=Ypred+norminv(0.99)*RMSE;

function Corr=CompCorr(x1,x2,r)
global No
if(No==0)
    Corr=prod(r.^((x1-x2).^2));
elseif(No==1)
    rho=x1-x2;
    rho1=abs(rho)./r;
    Corr=prod((exp(-rho1)).*(rho1+1));
elseif(No==2)
    rho=x1-x2;
    rho1=abs(rho)./r;
    Corr=prod((exp(-rho1)/3).*(rho1.^2+3*rho1+3)); 
end