function [Ypred,UCL,LCL,PosCov]=FunctionalGPPredictHeat(Din1,Din2,x,thetaopt,U,sigma2,ResR2I,R2I,R1)
%checked#1
%Inputs: [Din1,Din2]=same as FunctionalGPFitHeat, x=input setting at which prediction of functional output at points in M is desired, U=same as Uin in FunctionalGPFitHeat, [thetaopt,sigma2,ResR2I,R2I,R1]=the outputs of FunctionalGPFitHeat.
%Outputs: Ypred=vector of point predictions, UCL=vector of upper prediction/credible interval limits (0.99 quantile), LCL=vector of lower prediction/credible interval limits (0.01 quantile), PosCov=posterior covariance matrix of the functional output at x.

D1=Din1;
D2=Din2;
[n1, d1]=size(D1);
[n2, d2]=size(D2);
Maxx=max(D2,[],1);
D2=D2./repmat(Maxx,n2,1);
x=x./Maxx;
U=U.*repmat([1 Maxx(2:end)],n1,1);
rx=zeros(n2,1);
for i=1:n2
    rx(i,1)=CompCorr2(D2(i,:),x,thetaopt((d1+1):end));
end

dev=ResR2I*rx;
miu=U*([1 x(2:end)]');
Ypred=miu+dev;

rxx=CompCorr2(x,x,thetaopt((d1+1):end));
PosCov=sigma2*R1*(rxx-((rx')*R2I*rx));
Variances=max(diag(PosCov),0);
RMSE=sqrt(Variances);
LCL=Ypred-norminv(0.99)*RMSE;
UCL=Ypred+norminv(0.99)*RMSE;

function Corr=CompCorr2(x1,x2,r)

Corr=1;
for i=1:1
    rho1=abs(x1(i)-x2(i))./r(i);
    Corr=Corr*(exp(-rho1)*(rho1+1));
end

rho2=sqrt(sum((x1(2:end)-x2(2:end)).^2))./r(5);
Corr=Corr*(r(2)*x1(2)*x2(2)+r(3)*x1(3)*x2(3)+r(4)*x1(4)*x2(4)+exp(-rho2)*(rho2+1));