function [p,e,t]=MeshGen(Lx,Ly,Nx,Ny)
%checked#1
%This function generates [p,e,t] mesh data for a special type of mesh obtained from a regular grid   
%Inputs:  Lx=length of membrane in x direction, Ly=length of membrane in y direction, Nx=spacing of nodes in the x direction, Ny=spacing of nodes in y direction.
%Outputs: Mesh data in [p,e,t] triple format used as input to Matlab PDE Toolbox hyperbolic solver.

    nt=Nx*Ny*2;    
    [p, t, nNodes]=femTriangularMeshGenerator(Lx,Ly,Nx,nt);
    
    t=[t; ones(1,nt)];
       
a=find(p(1,:)==0);[~,ordera]=sort(p(2,a));sa=a(ordera); 
b=find(p(2,:)==Ly);[~,orderb]=sort(p(1,b));sb=b(orderb); 
c=find(p(1,:)==Lx);[~,orderc]=sort(p(2,c),'descend');sc=c(orderc); 
d=find(p(2,:)==0);[~,orderd]=sort(p(1,d),'descend');sd=d(orderd); 
e=[sa(1) kron(sa(2:(end-1)),ones(1,2)) sa(end) sb(1) kron(sb(2:(end-1)),ones(1,2)) sb(end) sc(1) kron(sc(2:(end-1)),ones(1,2)) sc(end) sd(1) kron(sd(2:(end-1)),ones(1,2)) sd(end)];

le=length(e);
e=reshape(e,2,le/2);
le=le/2;
e=[e; repmat([(0:(1/Ny):(1-1/Ny))*Ly (0:(1/Nx):(1-1/Nx))*Lx],1,2)];
e=[e; repmat([((1/Ny):(1/Ny):(1))*Ly ((1/Nx):(1/Nx):(1))*Lx],1,2)];

e=[e; zeros(1,le)];
for i=1:le
    if((p(1,e(1,i))==0)&&(p(1,e(2,i))==0))
        e(5,i)=1;
    elseif((p(1,e(1,i))==Lx)&&(p(1,e(2,i))==Lx))
        e(5,i)=3;
    elseif((p(2,e(1,i))==0)&&(p(2,e(2,i))==0))
        e(5,i)=2;       
    elseif((p(2,e(1,i))==Ly)&&(p(2,e(2,i))==Ly))
        e(5,i)=4;
    end
end
   
e=[e; zeros(1,le); ones(1,le)];
