%function WaveExample
%checked#1
%Variables: n=size of design=42, ntest=size of test set=60, storedata=vector of MAE, MSE, APIL, coverage for conditional linear GP model,  storedata2=vector of MAE, MSE, APIL, coverage for standard GP model.

delete(gcp('nocreate'))
parpool(1)
Min=[400 0.6 -1 -1 -1 -1];
Max=[600 2.1 1 1 1 1];
Range=Max-Min;
d=size(Min,2);
n=7*d;

Mid=(Max+Min)/2;
L=4; L2=d-L;
E=[zeros(1,L); full(speye(L))]; U=[]; Y=[];
for i=1:(L+1)
    [Y0,D1]=WaveEquation([Mid(1:L2) E(i,:)]);
    Y=[Y Y0];
    if(i>1)
        Y0=Y0-U(:,1);
    end
    U=[U Y0];
end
N=size(U,1); 

ntest=10*d;
Test=lhsdesign(ntest,d,'criterion','maximin');
UncodedTest=Test.*repmat(Range,ntest,1)+repmat(Min,ntest,1);
Ytest=zeros(N,ntest);
time0=zeros(ntest,1);
parfor i=1:ntest
    tic
    Ytest(:,i)=WaveEquation(UncodedTest(i,:));
    time0(i)=toc;
end

Design=[[repmat([0.5*ones(1,L2)],L+1,1) (E+1)/2]; lhsdesign(n-L-1,d,'criterion','maximin')];
UncodedDesign=Design.*repmat(Range,n,1)+repmat(Min,n,1);

Y=[Y zeros(N,n-L-1)];
parfor i=(L+2):n
    Y(:,i)=WaveEquation(UncodedDesign(i,:));
end

time1=zeros(1,ntest+1);
tic
[thetaopt,sigma2,ResR2I,R2I,R1]=FunctionalGPFitWave(D1,UncodedDesign,Y,U);
time1(1)=toc;
Ypred=zeros(N,ntest); UCL=zeros(N,ntest); LCL=zeros(N,ntest);
parfor i=1:ntest
    tic
    [Ypred(:,i),UCL(:,i),LCL(:,i)]=FunctionalGPPredictWave(D1,UncodedDesign,UncodedTest(i,:),thetaopt,U,sigma2,ResR2I,R2I,R1);
    time1(i+1)=toc;
end
MAE=zeros(ntest,1); MSE=zeros(ntest,1);
APL=zeros(ntest,1); Coverage=zeros(ntest,1);
parfor i=1:ntest
    absdev=abs(Ypred(:,i)-Ytest(:,i));
    MAE(i)=mean(absdev); MSE(i)=mean(absdev.^2);
    APL(i)=mean(UCL(:,i)-LCL(:,i));
    Coverage(i)=mean((LCL(:,i)<=Ytest(:,i)).*(Ytest(:,i)<=UCL(:,i)));  
end
storedata=[mean(MAE) mean(MSE) mean(APL) mean(Coverage)];

time2=zeros(1,ntest+1);
tic
[thetaopt,alpha,sigma2,R1,ResR2I,R2I]=FunctionalGPFit0(D1,Design,Y,1);
time2(1)=toc;
Ypred2=zeros(N,ntest); UCL2=zeros(N,ntest); LCL2=zeros(N,ntest);
parfor i=1:ntest
    tic
    [Ypred2(:,i), UCL2(:,i), LCL2(:,i)]=FunctionalGPPredict0(D1,Design,Y,1,Test(i,:),thetaopt,alpha,sigma2,R1,ResR2I,R2I);
    time2(i+1)=toc;
end
MAE2=zeros(ntest,1); MSE2=zeros(ntest,1);
APL2=zeros(ntest,1); Coverage2=zeros(ntest,1);
parfor i=1:ntest
    absdev2=abs(Ypred2(:,i)-Ytest(:,i));
    MAE2(i)=mean(absdev2); MSE2(i)=mean(absdev2.^2);
    APL2(i)=mean(UCL2(:,i)-LCL2(:,i));
    Coverage2(i)=mean((LCL2(:,i)<=Ytest(:,i)).*(Ytest(:,i)<=UCL2(:,i)));  
end
storedata2=[mean(MAE2) mean(MSE2) mean(APL2) mean(Coverage2)];

disp({'MAE, MSE, APIL, and coverage (of nominal 98% intervals) for conditional linear GP model'})
disp(storedata)
disp({'MAE, MSE, APIL, and coverage (of nominal 98% intervals) for standard GP model'})
disp(storedata2)
